# omq

Oracle Multi Querier (omq) - программа для выгрузки результатов SQL-запроса с нескольких серверов Oracle.

![Скриншот главного окна](doc/main-window.png)

## SQL-скрипты

1. Скрипты должны лежать в папке `sql` с расширением `.sql`.
2. Скрипт может начинаться со строки с комментарием `-- 1`, где `1` - номер колонки, значение которой будет заменяться наименованием сервера (нумерация с единицы). Если комментарий не обнаружен, будет использовано значение `1`.

## Параметры подключения к серверам

Список серверов должен быть указан в файле с расширением `.toml`, который лежит в папке `db`, со следующей структурой:

```ini
[Servers]
Name     = "<NAME>"
Login    = "<LOGIN>"
Password = "<PASSWORD>"
Hosts    = ["<HOST1>", "<HOST2>"]
Service  = "<SERVICE>"
```

где:
* `<NAME>` - наименование филиала
* `<HOST>` - адрес сервера
* `<SERVICE>` - наименование сервиса
* `<LOGIN>` - логин
* `<PASSWORD>` - пароль
* `<HOST1>`, `<HOST2>` - список хостов БД, которые будут перебираться в порядке указания
* `<SERVICE>` - наименование сервиса

например:

```ini
[Servers]
Name     = "Основной сервер"
Login    = "User1"
Password = "p@$$w0rd1"
Hosts    = ["db.server1.com", "db.server2.com"]
Service  = "mydb"

[Servers]
Name     = "Второй сервер сервер"
Login    = "User2"
Password = "p@$$w0rd2"
Hosts    = ["db.server3.com", "db.server4.com"]
Service  = "mydb"
```
